﻿using GazBooksClientLibrary.ClienteService;
using System;
using System.Collections.Generic;

namespace GazBooksClientLibrary.BLL
{
    public abstract class ClienteBLL
    {
        private static ClienteServiceClient cliente = new ClienteServiceClient();

        public static void InserirCliente(String nome, String cpf, UInt16 limite)
        {
            try
            {
                cliente.InserirCliente(nome, cpf, limite);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void ExcluirCliente(String cpf)
        {
            try
            {
                cliente.DeletarCliente(cpf);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static List<Cliente> BuscarCliente(String nome)
        {
            try
            {
                Cliente[] clientes = cliente.BuscarClientes(nome);
                if (clientes != null)
                {
                    return new List<Cliente>(clientes);
                }
                return null;
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }
    }
}
