﻿using GazBooksClientLibrary.EmprestimoService;
using System;
using System.Collections.Generic;

namespace GazBooksClientLibrary.BLL
{
    public abstract class EmprestimoBLL
    {
        private static EmprestimoServiceClient cliente = new EmprestimoServiceClient();

        public static void RegistrarDevolucao(UInt32 id)
        {
            try
            {
                cliente.RegistrarDevolucao(id);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void RegistrarDevolucaoPeriodico(UInt32 id)
        {
            try
            {
                cliente.RegistrarDevolucaoPeriodico(id);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void InserirEmprestimo(UInt32 id_obra, UInt32 id_cliente, String data_emp, String data_dev)
        {
            try
            {
                cliente.InserirEmprestimo(id_obra, id_cliente, data_emp, data_dev);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void InserirEmprestimoPeriodico(UInt32 id_obra, UInt32 id_cliente, String data_emp, String data_dev)
        {
            try
            {
                cliente.InserirEmprestimoPeriodico(id_obra, id_cliente, data_emp, data_dev);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static List<Emprestimo> BuscarEmprestimosPorCliente(UInt32 id_cliente)
        {
            try
            {
                Emprestimo[] emprestimos = cliente.BuscarEmprestimosPorCliente(id_cliente);
                List<Emprestimo> retorno = null;
                if (emprestimos != null)
                {
                    retorno = new List<Emprestimo>(emprestimos);
                }
                return retorno;
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }

        public static Emprestimo[] BuscarEmprestimosPendentes()
        {
            try
            {
                return cliente.BuscarEmprestimosPendentes();
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }

        public static Emprestimo[] BuscarEmprestimosDevolvidos()
        {
            try
            {
                return cliente.BuscarEmprestimosDevolvidos();
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }
    }
}
