﻿using GazBooksClientLibrary.LivroService;
using System;
using System.Collections.Generic;

namespace GazBooksClientLibrary.BLL
{
    public abstract class LivroBLL
    {
        private static LivroServiceClient cliente = new LivroServiceClient();

        public static List<Livro> BuscarTodos()
        {
            try
            {
                var array = cliente.BuscarTodosLivros();
                List<Livro> lista = null;
                if (array != null)
                {
                    lista = new List<Livro>(array);
                }
                return lista;
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }

        public static void ExcluirLivro(UInt32 id)
        {
            try
            {
                cliente.DeletarLivro(id);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void InserirLivro(String autor, String nome, UInt16 edicao, String tags, UInt16 qtde)
        {
            try
            {
                cliente.InserirLivro(autor, nome, edicao, tags, qtde);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void AlterarEstoque(UInt32 id, UInt16 novo_estoque)
        {
            try
            {
                cliente.AtualizarQuantidade(id, novo_estoque);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }
    }
}
