﻿using GazBooksClientLibrary.PeriodicoService;
using System;
using System.Collections.Generic;

namespace GazBooksClientLibrary.BLL
{
    public abstract class PeriodicoBLL
    {
        private static PeriodicoServiceClient cliente = new PeriodicoServiceClient();

        public static List<Periodico> BuscarTodos()
        {
            try
            {
                var array = cliente.BuscarTodosPeriodicos();
                List<Periodico> lista = null;
                if (array != null)
                {
                    lista = new List<Periodico>(array);
                }
                return lista;
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
                return null;
            }
        }

        public static void ExcluirPeriodico(UInt32 id)
        {
            try
            {
                cliente.DeletarPeriodico(id);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void InserirPeriodico(String nome, String data, String tags, UInt16 qtde)
        {
            try
            {
                cliente.InserirPeriodico(nome, data, tags, qtde);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }

        public static void AlterarEstoque(UInt32 id, UInt16 novo_estoque)
        {
            try
            {
                cliente.AtualizarQuantidade(id, novo_estoque);
            }
            catch (Exception e)
            {
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu: " + e.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }
        }
    }
}
