﻿using GazBooksClientLibrary.BLL;
using System;
using System.Windows.Forms;

namespace GazBooksForms
{
    public partial class AlterarEstoque : Form
    {
        public enum TipoItem
        {
            Periodico, Livro
        }

        private TipoItem i;       

        public AlterarEstoque(TipoItem i)
        {
            this.i = i;
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                UInt32 id = UInt32.Parse(maskedTextBox1.Text);
                UInt16 qtdeNova = UInt16.Parse(maskedTextBox2.Text);
                switch (i)
                {
                    case TipoItem.Livro:
                        LivroBLL.AlterarEstoque(id, qtdeNova);
                        break;
                    default:
                        PeriodicoBLL.AlterarEstoque(id, qtdeNova);
                        break;
                }
            }
            catch(FormatException)
            {
                MessageBox.Show("Os campos são todos obrigatorios.");
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Algum valor inserido para ser parseado era invalido.", System.Diagnostics.EventLogEntryType.Warning, 1);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Erro desconhecido:\n" + ex.Message);
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Ocorreu um erro desconhecido: " + ex.Message, System.Diagnostics.EventLogEntryType.Error, 2);
            }           
        }
    }
}
