﻿using System;
using System.Windows.Forms;

namespace GazBooksForms
{
    public partial class CadastrarUsuario : Form
    {
        private String[] mensagens = new String[4];

        public CadastrarUsuario()
        {
            if (System.Globalization.CultureInfo.CurrentCulture.Name.Equals("en"))
            {
                mensagens[0] = "All fields are required.";
                mensagens[1] = "This user name is taken. Please choose a different user name.";
                mensagens[2] = "GazBooks has fallen prey to an unknown error whilst trying to process your request.";
                mensagens[3] = "Your registration was completed successfully.";
            }
            else
            {
                mensagens[0] = "Todos os campos sao obrigatorios.";
                mensagens[1] = "Esse nome ja foi escolhido, por favor escolha outro.";
                mensagens[2] = "Um erro desconhecido ocorreu ao processar sua requisicao.";
                mensagens[3] = "Seu registro foi concluido com sucesso.";
            }
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            String user = textBox1.Text;
            String pass = textBox2.Text;
            if (user.Equals("") || pass.Equals(""))
            {
                MessageBox.Show(mensagens[0]);
                EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "O usuario deixou campos em branco durante o cadastro.", System.Diagnostics.EventLogEntryType.Warning, 3);
                return;
            }
            UInt16 resp = GazBooksClientLibrary.BLL.UsuarioBLL.InserirUsuario(user, pass);
            switch (resp)
            {
                case 0:
                    MessageBox.Show(mensagens[3]);
                    break;
                case 1:
                    MessageBox.Show(mensagens[1]);
                    break;
                default:
                    MessageBox.Show(mensagens[2]);
                    EventViewDLL.GeradorEventView.GravarEntrada("GazBooks", "Um erro desconhecido ocorreu.", System.Diagnostics.EventLogEntryType.Error, 2);
                    break;
            }
        }
    }
}
