﻿using GazBooksClientLibrary.BLL;
using GazBooksClientLibrary.EmprestimoService;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace GazBooksForms
{
    public partial class ListaEmprestimos : Form
    {
        private bool buscarClientes = false;
        private UInt32 id;

        public ListaEmprestimos(UInt32 id)
        {
            buscarClientes = true;
            this.id = id;
            InitializeComponent();
        }

        public ListaEmprestimos()
        {
            InitializeComponent();
        }


        private void ListaEmprestimos_Load(object sender, System.EventArgs e)
        {
            List<Emprestimo> emprestimos = new List<Emprestimo>();
            if (buscarClientes)
            {
                List<Emprestimo> bags = EmprestimoBLL.BuscarEmprestimosPorCliente(id);
                if (bags != null)
                {
                    emprestimos.AddRange(bags);
                }
            }
            else
            {
                Emprestimo[] bags = EmprestimoBLL.BuscarEmprestimosDevolvidos();
                if (bags != null)
                {
                    emprestimos.AddRange(bags);
                }
                bags = EmprestimoBLL.BuscarEmprestimosPendentes();
                if (bags != null)
                {
                    emprestimos.AddRange(bags);
                }
            }
            this.dataGridView1.DataSource = emprestimos;
        }
    }
}
