﻿using GazBooksLibrary.DAO;
using GazBooksLibrary.Model;
using System;
using System.Collections.Generic;
using System.ServiceModel;

namespace GazBooksLibrary.BLL
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class ClienteService : IClienteService
    {
        private static ClienteDAO dao = new ClienteDAO();

        public List<Cliente> BuscarClientes(String nome)
        {
            lock (dao)
            {
                return dao.BuscarClientes(nome);
            }
        }

        public void InserirCliente(String nome, String cpf, UInt16 limite)
        {
            lock (dao)
            {
                dao.InserirCliente(nome, cpf, limite);
            }
        }

        public void AlterarNome(String cpf, String nomeNovo)
        {
            lock (dao)
            {
                dao.AlterarNome(cpf, nomeNovo);
            }
        }

        public void AlterarLimite(String cpf, UInt16 novoLimite)
        {
            lock (dao)
            {
                dao.AlterarLimite(cpf, novoLimite);
            }
        }

        public void DeletarCliente(String cpf)
        {
            lock (dao)
            {
                dao.DeletarCliente(cpf);
            }
        }
    }
}
