﻿using GazBooksLibrary.Model;
using System;
using System.Collections.Generic;
using System.ServiceModel;

namespace GazBooksLibrary.BLL
{
    [ServiceContract]
    public interface IEmprestimoService
    {
        [OperationContract]
        bool InserirEmprestimoPeriodico(UInt32 id_periodico, UInt32 id_cliente, String data_emprestimo, String data_devolucao);

        [OperationContract]
        bool InserirEmprestimo(UInt32 id_livro, UInt32 id_cliente, String data_emprestimo, String data_devolucao);

        [OperationContract]
        void RegistrarDevolucaoPeriodico(UInt32 id_emprestimo);

        [OperationContract]
        void RegistrarDevolucao(UInt32 id_emprestimo);

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosPorCliente(UInt32 id_cliente);

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosPorPeriodico(UInt32 id_periodico);

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosPorLivro(UInt32 id_livro);

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosPorData(String data);

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosDevolvidos();

        [OperationContract]
        List<Emprestimo> BuscarEmprestimosPendentes();
    }
}
