﻿using GazBooksLibrary.DAO;
using GazBooksLibrary.Model;
using System;
using System.Collections.Generic;
using System.ServiceModel;

namespace GazBooksLibrary.BLL
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class LivroService : ILivroService
    {
        private LivroDAO dao = new LivroDAO();

        public void InserirLivro(String autor, String nome, UInt16 edicao, String tags, UInt16 qtde)
        {
            lock (dao)
            {
                dao.InserirLivro(autor, nome, edicao, tags, qtde);
            }
        }

        public void DeletarLivro(UInt32 id)
        {
            lock (dao)
            {
                dao.DeletarLivro(id);
            }
        }

        public void AtualizarQuantidade(UInt32 id, UInt16 qtde)
        {
            lock (dao)
            {
                dao.AtualizarQuantidade(id, qtde);
            }
        }

        public Livro BuscarLivroPorID(UInt32 id)
        {
            lock (dao)
            {
                return dao.BuscarLivroPorID(id);
            }
        }

        public List<Livro> BuscarTodosLivros()
        {
            lock (dao)
            {
                return dao.BuscarTodosLivros();
            }
        }

        public List<Livro> BuscarLivrosPorNome(String nome)
        {
            lock (dao)
            {
                return dao.BuscarLivrosPorNome(nome);
            }
        }

        public List<Livro> BuscarLivrosPorAutor(String autor)
        {
            lock (dao)
            {
                return dao.BuscarLivrosPorAutor(autor);
            }
        }

        public List<Livro> BuscarLivrosPorTags(String tags)
        {
            lock (dao)
            {
                return dao.BuscarLivrosPorTags(tags.Split(';'));
            }
        }
    }
}
