﻿using GazBooksLibrary.DAO;
using GazBooksLibrary.Model;
using System;
using System.Collections.Generic;

namespace GazBooksLibrary.BLL
{
    public class PeriodicoService : IPeriodicoService
    {
        private PeriodicoDAO dao = new PeriodicoDAO();

        public void InserirPeriodico(String nome, String data_pub, String tags, UInt16 qtde)
        {
            lock (dao)
            {
                dao.InserirPeriodico(nome, data_pub, tags, qtde);
            }
        }

        public void DeletarPeriodico(UInt32 id)
        {
            lock (dao)
            {
                dao.DeletarPeriodico(id);
            }
        }

        public void AtualizarQuantidade(UInt32 id, UInt16 qtde)
        {
            lock (dao)
            {
                dao.AtualizarQuantidade(id, qtde);
            }
        }

        public Periodico BuscarPeriodicoPorID(UInt32 id)
        {
            lock (dao)
            {
                return dao.BuscarPeriodicoPorID(id);
            }
        }

        public List<Periodico> BuscarTodosPeriodicos()
        {
            lock (dao)
            {
                return dao.BuscarTodosPeriodicos();
            }
        }

        public List<Periodico> BuscarPeriodicosPorNome(String nome)
        {
            lock (dao)
            {
                return dao.BuscarPeriodicosPorNome(nome);
            }
        }

        public List<Periodico> BuscarPeriodicosPorData(String data)
        {
            lock (dao)
            {
                return dao.BuscarPeriodicosPorData(data);
            }
        }

       public List<Periodico> BuscarPeriodicosPorTags(String tags)
        {
            lock (dao)
            {
                return dao.BuscarPeriodicosPorTags(tags.Split(';'));
            }
        }
    }
}
