﻿using GazBooksLibrary.DAO;
using GazBooksLibrary.Model;
using System;
using System.ServiceModel;

namespace GazBooksLibrary.BLL
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class UsuarioService : IUsuarioService
    {
        private static UsuarioDAO dao = new UsuarioDAO();

        public Usuario BuscarUsuario(String username, String senha)
        {
            lock (dao)
            {
                return dao.BuscarUsuario(username, senha);
            }
        }

        public UInt16 InserirUsuario(String username, String senha)
        {
            lock (dao)
            {
                try
                {
                    dao.InserirUsuario(username, senha);
                    return 0;
                }
                catch (System.Data.SQLite.SQLiteException ex)
                {
                    if (ex.ErrorCode == 19)
                    {
                        return 1;
                    }
                }
            }
            return 2;
        }

        public void AlterarSenha(String username, String novaSenha)
        {
            lock (dao)
            {
                dao.AlterarSenha(username, novaSenha);
            }
        }

        public void DeletarUsuario(String username)
        {
            lock (dao)
            {
                dao.DeletarUsuario(username);
            }
        }
    }
}
