﻿using GazBooksLibrary.Model;
using System;
using System.Data.SQLite;

namespace GazBooksLibrary.DAO
{
    public class UsuarioDAO
    {
        private String src = @"Data Source=C:\Users\Bruno\GazBooks\GazBooks.db";
        //private String src = @"Data Source=C:\Users\Cida\Desktop\gazbooks\GazBooks.db";

        public void InserirUsuario(String username, String senha)
        {
            String query = "insert into usuarios (username, senha) values (@username, @senha)";
            SQLiteCommand cmd = new SQLiteCommand(query);
            cmd.Parameters.AddWithValue("@username", username);
            cmd.Parameters.AddWithValue("@senha", senha);
            SQLiteConnection con = new SQLiteConnection(src);
            cmd.Connection = con;
            con.Open();
            SQLiteTransaction tr = con.BeginTransaction();
            cmd.ExecuteNonQuery();
            tr.Commit();
            tr.Dispose();
            cmd.Dispose();
            con.Close();
        }

        public void DeletarUsuario(String username)
        {
            String query = "delete from usuarios where username like @username";
            SQLiteCommand cmd = new SQLiteCommand(query);
            cmd.Parameters.AddWithValue("@username", username);
            SQLiteConnection con = new SQLiteConnection(src);
            cmd.Connection = con;
            con.Open();
            SQLiteTransaction tr = con.BeginTransaction();
            cmd.ExecuteNonQuery();
            tr.Commit();
            tr.Dispose();
            cmd.Dispose();
            con.Close();
        }

        public void AlterarSenha(String username, String novaSenha)
        {
            String query = "update usuarios set senha = @senha where username like @username";
            SQLiteCommand cmd = new SQLiteCommand(query);
            cmd.Parameters.AddWithValue("@username", username);
            cmd.Parameters.AddWithValue("@senha", novaSenha);
            SQLiteConnection con = new SQLiteConnection(src);
            cmd.Connection = con;
            con.Open();
            SQLiteTransaction tr = con.BeginTransaction();
            cmd.ExecuteNonQuery();
            tr.Commit();
            tr.Dispose();
            cmd.Dispose();
            con.Close();
        }

        public Usuario BuscarUsuario(String username, String senha)
        {
            String query = "select * from usuarios where username like @username and senha = @senha";
            SQLiteCommand cmd = new SQLiteCommand(query);
            cmd.Parameters.AddWithValue("@username", username);
            cmd.Parameters.AddWithValue("@senha", senha);
            SQLiteConnection con = new SQLiteConnection(src);
            cmd.Connection = con;
            con.Open();
            Usuario u = null;
            using (var reader = cmd.ExecuteReader())
            {
                if (reader.Read())
                {
                    u = new Usuario();
                    u.ID = (UInt32)reader.GetInt32(0);
                    u.Username = reader.GetString(1);
                    u.Senha = reader.GetString(2);
                }
            }
            cmd.Dispose();
            con.Close();
            return u;
        }
    }
}
