﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data.SQLite;

namespace GazBooksTest
{
    [TestClass]
    public class TestarCadastros
    {
        private String src = @"Data Source=C:\Users\Cida\Desktop\gazbooks\GazBooksTest.db";
        [TestMethod]
        public void TestarUsuario()
        {
            try
            {
                String query = "insert into usuarios (username, senha) values (@username, @senha)";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@username", "gaz");
                cmd.Parameters.AddWithValue("@senha", "123456");
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarCliente()
        {
            try
            {
                String query = "insert into clientes (nome, cpf, limite_emprestimos) values (@nome, @cpf, @limite)";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@nome", "Teste");
                cmd.Parameters.AddWithValue("@cpf", "12345678901");
                cmd.Parameters.AddWithValue("@limite", 10);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarLivro()
        {
            try
            {
                String query = "insert into livros (autor, nome, edicao, tags, qtde) values (@autor, @nome, @edicao, @tags, @qtde)";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@autor", "Mano");
                cmd.Parameters.AddWithValue("@nome", "Livro dos testes sagrados");
                cmd.Parameters.AddWithValue("@edicao", 1337);
                cmd.Parameters.AddWithValue("@tags", "hue; teste;");
                cmd.Parameters.AddWithValue("@qtde", 5);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarPeriodico()
        {
            try
            {
                String query = "insert into periodicos (nome, data_pub, tags, qtde) values (@nome, @data_pub, @tags, @qtde)";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@nome", "afa");
                cmd.Parameters.AddWithValue("@data_pub", "06-11-2013");
                cmd.Parameters.AddWithValue("@tags", "fhgdg;gsfsg;");
                cmd.Parameters.AddWithValue("@qtde", 5);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarEmprestimo()
        {
            try
            {
                String query = "insert into emprestimos " +
                    "(id_cliente, id_livro, data_emprestimo, data_devolucao, devolvido) " +
                    "values (@id_cliente, @id_obra, @data_emprestimo, @data_devolucao, @devolvido)";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@id_cliente", 1);
                cmd.Parameters.AddWithValue("@id_obra", 1);
                cmd.Parameters.AddWithValue("@data_emprestimo", "11-11-1111");
                cmd.Parameters.AddWithValue("@data_devolucao", "12-11-1111");
                cmd.Parameters.AddWithValue("@devolvido", false);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }
    }
}
