﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data.SQLite;

namespace GazBooksTest
{
    [TestClass]
    public class TestarRemocoes
    {
        private String src = @"Data Source=C:\Users\Cida\Desktop\gazbooks\GazBooksTest.db";

        [TestMethod]
        public void TestarUsuario()
        {
            try
            {
                String query = "delete from usuarios where username like @username";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@username", "gaz");
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarCliente()
        {
            try
            {
                String query = "delete from clientes where cpf like @cpf";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@cpf", "12345678901");
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarLivro()
        {
            try
            {
                String query = "delete from livros where id = @id";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@id", 1);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarPeriodico()
        {
            try
            {
                String query = "delete from periodicos where id = @id";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@id", 1);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }

        [TestMethod]
        public void TestarEmprestimo()
        {
            try
            {
                String query = "delete from emprestimos where id = @id";
                SQLiteCommand cmd = new SQLiteCommand(query);
                cmd.Parameters.AddWithValue("@id", 1);
                SQLiteConnection con = new SQLiteConnection(src);
                cmd.Connection = con;
                con.Open();
                SQLiteTransaction tr = con.BeginTransaction();
                cmd.ExecuteNonQuery();
                tr.Commit();
                tr.Dispose();
                cmd.Dispose();
                con.Close();
            }
            catch (Exception e)
            {
                Assert.Fail(e.Message);
            }
        }
    }
}
